Node
Date: 2019-10-22

org.jmol.bspt

## Class Node

- java.lang.Object
- - org.jmol.bspt.Element
  - - org.jmol.bspt.Node

-     class Node
      extends Element

  Nodes of the bspt. It is a binary tree so nodes contain two children, called left and right. Nodes split along one dimension. The instance variable dim holds the dimension along which this node is split. Each child holds the minimum and maximum values for its subtree when split along the specified dim.

  The current implementation allows for the case where the maximum left value is == the minimum right value. This can happen when the tree is filled with coordinate values that contain the same value along one dimension ... as with very regular crystals

  The tree is not kept balanced.

  Author:
    Miguel, miguel@jmol.org

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `(package private) int` | `dim`
    `(package private) Element` | `eleLeft`
    `(package private) Element` | `eleRight`
    `(package private) float` | `maxLeft`
    `(package private) float` | `maxRight`
    `(package private) float` | `minLeft`
    `(package private) float` | `minRight`

    - ### Fields inherited from class org.jmol.bspt.Element

      `bspt, count`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `Node(Bspt bspt, int level, Leaf leafLeft)`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `(package private) Element` | `addTuple(int level, javajs.util.T3 tuple)`
    `(package private) static float` | `getDimensionValue(javajs.util.T3 pt, int dim)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### dim

          int dim

    - #### minLeft

          float minLeft

    - #### maxLeft

          float maxLeft

    - #### eleLeft

          Element eleLeft

    - #### minRight

          float minRight

    - #### maxRight

          float maxRight

    - #### eleRight

          Element eleRight

  - ### Constructor Detail

    - #### Node

          Node(Bspt bspt,
               int level,
               Leaf leafLeft)

      Parameters:
        `bspt` -
        `level` -
        `leafLeft` -

  - ### Method Detail

    - #### addTuple

          Element addTuple(int level,
                           javajs.util.T3 tuple)

      Specified by:
        `addTuple` in class `Element`

    - #### getDimensionValue

          static float getDimensionValue(javajs.util.T3 pt,
                                         int dim)